#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>
#include <termios.h>


   int fd;
int port;
int a1,a2,a3,a4,a5,a6,a7,a8;
int k;

//Die init funktion fr den Com port
int open_port()
  {
  /*
   * Open serial Port
   *
   * RS232-Parameter
   * - 19200 baud
   * - 8 bits/byte
   * - no parity
   * - no handshake
   * - 1 stop bit
   */



   struct termios options;
   switch (port)
     {
     case 0: fd = open("/dev/ttyS0", O_RDWR | O_NOCTTY | O_NDELAY); break;
     case 1: fd = open("/dev/ttyS1", O_RDWR | O_NOCTTY | O_NDELAY); break;
     case 2: fd = open("/dev/ttyS2", O_RDWR | O_NOCTTY | O_NDELAY); break;
     case 3: fd = open("/dev/ttyS3", O_RDWR | O_NOCTTY | O_NDELAY); break;
     case 4: fd = open("/dev/ttyUSB0", O_RDWR | O_NOCTTY | O_NDELAY); break;
     case 5: fd = open("/dev/ttyUSB1", O_RDWR | O_NOCTTY | O_NDELAY); break;
     case 6: fd = open("/dev/ttyUSB2", O_RDWR | O_NOCTTY | O_NDELAY); break;
     default: fd = -1;
     }
   if (fd >= 0)
     {

     fcntl(fd, F_SETFL, 0);
     if (tcgetattr(fd, &options) != 0) return(-1);
     bzero(&options, sizeof(options)); 

     cfsetspeed(&options, B9600);       //9600 Baud
     /* Alternativ:                                         
       cfsetispeed(&options, B19200);                      
       cfsetospeed(&options, B19200);        */

     
     options.c_cflag &=  PARENB;         // kein Paritybit 
     options.c_cflag &=  CSTOPB;         // 1 Stoppbit 
     options.c_cflag &=  CSIZE;          // 8 Datenbits 
     options.c_cflag |= CS8;
     options.c_cflag |= (CLOCAL | CREAD);
     // Kein Echo, keine Steuerzeichen, keine Interrupts 
     options.c_lflag &=  (ICANON | ECHO | ECHOE | ISIG);
     options.c_oflag &=  OPOST;          // "raw" Input 
     options.c_cc[VMIN]  = 0;            
     options.c_cc[VTIME] = 10;           // Timeout 10 Sec. 
     tcflush(fd,TCIOFLUSH);
     if (tcsetattr(fd, TCSAFLUSH, &options) != 0) return(-1);

     fcntl(fd, F_SETFL, FNDELAY);
     fcntl(fd, F_SETFL, 0);
     }
  return(fd);
  }


#define ZEILEN 5
#define SPALTEN 8

unsigned char card_ID[ZEILEN][SPALTEN] =                //Die ID des  
   {{0xFF,0xC5,0x38,0x2D,0x19,0xD1,0xC9,0x5A},         //RFID tags
    {0xFF,0xC5,0x38,0x2D,0x19,0xD1,0xC9,0x5A},     
    {0xFF,0xC5,0x38,0x2D,0x19,0xD1,0xC9,0x5A},   
    {0xFF,0xC5,0x38,0x2D,0x19,0xD1,0xC9,0x5A},    
    {0xFF,0xC5,0x38,0x2D,0x19,0xD1,0xC9,0x5A}  
   }; 


   //EIN Zeichen senden 

void uart_putc(unsigned char zeichen)
{
  // fd: globaler Dateibezeichner fr die RS232 Schnittstelle
  write(fd, &zeichen, sizeof(unsigned char));
}


   //Hauptprogramm

int main(void)
{
   unsigned char zeichen;
   unsigned char i, j;
int choice;

printf("\nRFID emulator by Alex G. 2009");
printf("\nv1.0");
printf("\nManual key entering");
printf("\n");
printf("\nChoose the Com port");
printf("\n0-3 normal RS232 ports");
printf("\n4-6 USB to RS232 ports");
printf("\n->");
scanf("%i",&port);

open_port(); //seriellen port ffnen

printf("\n");

printf("\nExample: First 8bits->FF");

printf("\n");

  

   printf("\nFirst 8bits->");
   scanf("%x",&a1);

   printf("\nSecond 8bits->");
   scanf("%x",&a2);

   printf("\nThird 8bits->");
   scanf("%x",&a3);

   printf("\nFourth 8bits->");
   scanf("%x",&a4);

   printf("\nFifth 8bits->");
   scanf("%x",&a5);

   printf("\nSixth 8bits->");
   scanf("%x",&a6);

   printf("\nSeventh 8bits->");
   scanf("%x",&a7);

   printf("\nEighth 8bits->");
   scanf("%x",&a8);

   for(k = 0; k < 5;k++)
   {
	   a1 = card_ID[k][0];
	   a2 = card_ID[k][1];
	   a3 = card_ID[k][2];
	   a4 = card_ID[k][3];
	   a5 = card_ID[k][4];
	   a6 = card_ID[k][5];
	   a7 = card_ID[k][6];
	   a8 = card_ID[k][7];

   }

   uart_putc(0x73); // Start

   //senden des arrays ber die serielle schnittstelle
   for (i = 0; i < ZEILEN; i++)
   {
     for (j = 0; j < SPALTEN; j++)
     {
       zeichen = card_ID[i][j];
       uart_putc(zeichen);

     }
   }

   uart_putc(0x65); // Exit


printf("\n");
printf("\nID gesendet!");
printf("\ntfh.alex94@googlemail.com");
printf("\n");


}

